
      SUBROUTINE MEGTAR

C ============================================================= C
C This subroutine contains the definition of the target.        C
C ============================================================= C

      IMPLICIT NONE
      
      CALL TARMAT
      CALL TARMED
      CALL TARVOL
      CALL TARPOS

      RETURN
      END

C ============================================================= C

      SUBROUTINE TARCAR

C ============================================================= C
C Cards for target.                                             C
C ============================================================= C

      IMPLICIT NONE

#include"uniinc/megtar.inc"

      OPEN(5, FILE = 'cartar.dat', STATUS = 'OLD')
      READ(5,*) TARDIM
      CLOSE (5)

      RETURN
      END

C ============================================================= C

      SUBROUTINE TARMAT

C ============================================================= C
C Target materials.                                             C
C ============================================================= C

      IMPLICIT NONE

C PET Polyethylene. 
      REAL APET(2),ZPET(2),WPET(2),DPET
      DATA APET/12.011,1.008/
      DATA ZPET/6.,1./
      DATA WPET/1.,2./
      DATA DPET/.94/	

C HEL Helium.
      REAL AHEL,ZHEL,DHEL,RHEL
      DATA AHEL/4.003/
      DATA ZHEL/2./
      DATA DHEL/1.8E-4/
      DATA RHEL/528000./

      CALL GSMIXT(61,'PET for Target$',APET,ZPET,DPET,-2,WPET)
C Helium (gaseous!).
      CALL GSMATE(63,'HEL $',AHEL,ZHEL,DHEL,RHEL,0.,0.,1)

      RETURN
      END

C ============================================================= C

      SUBROUTINE TARMED

C ============================================================= C
C Tracking parameters for target.                               C
C ============================================================= C

      IMPLICIT NONE
      INTEGER IFIELD,ISVOL
      REAL    FIELDM,TMAXFD,STEMAX,DEEMAX,EPSIL,STMIN

      ISVOL = 0

C Magnetic field is specified by the user. The maximum value is 
C given in Kilogauss and the field is directed along the Z axis.
      IFIELD = 1
      FIELDM = 15.

C Maximum angular deviation.                       
      TMAXFD = 10.0  

C Maximum step permitted (cm).
      STEMAX = 0.2

C Maximum fractional energy loss.
      DEEMAX = 0.01               

C Boundary crossing precision.
      EPSIL = 0.001 

C Minimum value for the maximum step imposed by dedx/mult scatt etc.
      STMIN = 0.001

C Tracking medium 61 target: (polyethylene). 
      CALL GSTMED(61,'Target             $',61,
     +      -1,IFIELD,FIELDM,TMAXFD,STEMAX,DEEMAX,EPSIL,STMIN,0,0)        
C SPE medium 43: Helium.
      CALL GSTMED(63,'Helium for Target  $',63, -1,IFIELD,FIELDM,
     +     TMAXFD,STEMAX,DEEMAX,EPSIL,STMIN,0,0)   

      RETURN
      END

C ============================================================= C

      SUBROUTINE TARVOL

C ============================================================= C
C Target volume.                                                C
C ============================================================= C

      IMPLICIT NONE

#include"uniinc/megtar.inc"

      REAL TARFRA(3)
      DATA TARFRA/0., 10., 50.5/
      REAL TARGDI(3)
      INTEGER IVOLU

      TARGDI(1) = TARDIM(1)*0.5
      TARGDI(2) = TARDIM(2)*0.5
      TARGDI(3) = TARDIM(3)*0.5
      CALL GSVOLU('TARG','BOX ',61,TARGDI,3,IVOLU) 
      CALL GSVOLU('TARF','TUBE',63,TARFRA,3,IVOLU)
      RETURN
      END

C ============================================================= C

      SUBROUTINE TARPOS

C ============================================================= C
C Target positioning.                                           C
C ============================================================= C

      IMPLICIT NONE

C ============================================================= C
C Target slanted by 22 degrees with respect to the beam axis.   C
C ============================================================= C

      CALL GSROTM(100,22.,0.,90.,90.,112.,0.)
      CALL GSPOS('TARG', 1,'TARF',0.,0.,0.,100,'ONLY')
      CALL GSPOS('TARF', 1,'FRAM',0.,0.,0.,  0,'ONLY')

      RETURN
      END











